'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactI18next = require('react-i18next');

var _settings2 = require('../../settings');

var _hooks = require('../../utils/hooks');

var _Element = require('./Element');

var _Element2 = _interopRequireDefault(_Element);

require('../../../../../css/generator/Slidebar.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Sidebar = function Sidebar(props) {
  var _useTranslation = (0, _reactI18next.useTranslation)(),
      t = _useTranslation.t;

  var _useStore = (0, _hooks.useStore)(),
      _useStore$userProps = _useStore.userProps,
      userProps = _useStore$userProps === undefined ? {} : _useStore$userProps;

  var settings = userProps.settings;

  var _settings = Array.isArray(settings) ? settings : _settings2.defaultSettings;

  return _react2.default.createElement(
    'div',
    { className: 'left-layout w5-l w4' },
    Array.isArray(_settings) ? _settings.map(function (item, idx) {
      if (item && item.show === false) {
        return null;
      }
      return _react2.default.createElement(
        'div',
        { key: idx },
        _react2.default.createElement(
          'p',
          { className: 'f6 b' },
          t(item.title, { ns: 'components' })
        ),
        _react2.default.createElement(
          'ul',
          { className: 'pl0' },
          Array.isArray(item.widgets) ? item.widgets.filter(function (item) {
            return item.show !== false;
          }).map(function (widget, idx) {
            return _react2.default.createElement(_Element2.default, _extends({ key: idx.toString() }, props, widget));
          }) : _react2.default.createElement(
            'div',
            null,
            t('此处配置有误')
          )
        )
      );
    }) : _react2.default.createElement(
      'div',
      null,
      t('配置错误：Setting不是数组')
    )
  );
};

exports.default = Sidebar;